use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# HTTP⥸塼
#						(C)2006-2013 nabe / nabe@abk
#------------------------------------------------------------------------------
# ʰ׼ HTTP ⥸塼ǤܳŪʻѤˤѤޤ
#
package Satsuki::Base::HTTP;
our $VERSION = '1.30';
#------------------------------------------------------------------------------
use Socket;
# use Symbol ();
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	my $ROBJ  = shift;

	$self->{ROBJ}    = $ROBJ;
	$self->{cookie}  = {};	#  hash
	$self->{timeout} = 30;
	$self->{auto_redirect} = 1;	# 쥯Ƚ򣱲ɤ
	if (defined $ROBJ) {
		$self->{http_agent} = "Satsuki-system $ROBJ->{VERSION} ";
	}
	$self->{http_agent} = "Simple HTTP agent $VERSION";
	$self->{use_cookie} = 0;
	return $self;
}
#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ۥȤФƽ
#------------------------------------------------------------------------------
sub get_data {
	my $self = shift;
	my $host = shift;
	my $port = shift;

	my $socket = $self->connect_host($host, $port);
	if (!defined $socket) { return ; }
	my $res    = $self->send_http_request($socket, $host, @_);
	if (!defined $res)    { return ; }
	close($socket);

	return $res;
}

#------------------------------------------------------------------------------
# ۥȤ³
#------------------------------------------------------------------------------
sub connect_host {
	my ($self, $host, $port) = @_;

	my $ip_bin = inet_aton($host);		# IP Ѵ
	if ($ip_bin eq '') {
		return $self->error(undef, "Can't find host '%s'", $host);
	}
	my $sockaddr = pack_sockaddr_in($port, $ip_bin);
	my $sh; # = Symbol::gensym();
	if (! socket($sh, Socket::PF_INET(), Socket::SOCK_STREAM(), 0)) {
		return $self->error(undef, "Can't open socket");
	}
	{
		local $SIG{ALRM} = sub { close($sh); };
		alarm( $self->{timeout}+1 );
		if (! connect($sh, $sockaddr)) {
			return $self->error($sh, "Can't connect %s", $host);
		}
		alarm(0);
	}

	return $sh;
}

#------------------------------------------------------------------------------
# GET, POST, HEAD ʤɤꡢǡ
#------------------------------------------------------------------------------
sub send_http_request {
	my $self   = shift;
	my $socket = shift;
	my $host   = shift;
	my $ROBJ   = $self->{ROBJ};
	{
		my $request = join('', @_);
		syswrite($socket, $request, length($request));
		$self->{debug_file} && $ROBJ->fappend_lines($self->{debug_file}, $request);
	}
	my @response;
	my $vec_in = '';
	vec($vec_in, fileno($socket), 1) = 1;
	my ($r, $timeout);
	{
		local $SIG{ALRM} = sub { close($socket); $timeout=1; };
		alarm( $self->{timeout}+1 );
		$r = select($vec_in, undef, undef, $self->{timeout});
		if (vec($vec_in, fileno($socket), 1) ) {
			@response = <$socket>;
		}
		alarm(0);
		close($socket);
	}
	$self->{debug_file} && $ROBJ->fappend_lines($self->{debug_file}, \@response);
	if (! @response) {
		if (!$r || $timeout) {
			return $self->error($socket, "Connection timeout '%s' (timeout %d sec)", $host, $self->{timeout});
		}
		return $self->error($socket, "Connection closed by '%s'", $host);
	}

	$self->parse_status_line($response[0], $host);
	return \@response;
}

#-------------------------------------------------
# status lineν
#-------------------------------------------------
sub parse_status_line {
	my $self   = shift;
	my $status = int( (split(' ', shift))[1] );
	my $host   = shift;
	$self->{status} = $status;
	if ($status != 200 && ($status<301 || 304<$status)) {
		return $self->error(undef, "Error response from '%s' (status %d)", $host, $status);
	}
}



###############################################################################
# ̥ӥ롼
###############################################################################
# Cookieݥꥷ
#	expires ̵ʤ٤session cookieȤƽ
#------------------------------------------------------------------------------
# cookieon/offʥǥե:off
#------------------------------------------------------------------------------
sub cookie_on {
	my $self = shift;
	$self->{use_cookie} = 1;
}
sub cookie_off {
	my $self = shift;
	$self->{use_cookie} = 0;
}

#------------------------------------------------------------------------------
# ꤷURLGETȥǡ֤
#------------------------------------------------------------------------------
#-----------------------------------------------------------
# Redirect
#-----------------------------------------------------------
sub get {
	my $self = shift;
	my $url  = shift;
	$self->{redirects} = 0;
	while (1) {
		my $r = $self->do_get($url, @_);
		# ｪλ
		if (!$self->{location} || $self->{status}<301 || 303<$self->{status}) {
			return $r;
		}
		# Redirect
		$url = $self->{location};
		if ((++$self->{redirects}) > $self->{auto_redirect}) { return $r; }
	}
}
#-----------------------------------------------------------
# GET
#-----------------------------------------------------------
sub do_post {
	my $self = shift;
	return $self->do_request('POST', @_);
}
sub do_get {
	my $self = shift;
	return $self->do_request('GET', @_);
}
sub do_request {
	my ($self, $method, $url, $_header, $post_data) = @_;
	my $cookie = $self->{cookie};
	my $https = ($url =~ m|^https://|i);

	if ($url !~ m|^https?://([^/:]*)(:(\d+))?(.*)|) {
		return $self->error(undef, "URL format error '%s'", $url);
	}
	my $host = $1;
	my $port = $3 || ($https ? 443 : 80);
	my $path = $4 || '/';
	#----------------------------------------------------------------------
	# Cookieν
	#----------------------------------------------------------------------
	my $http_cookie;
	if ($self->{use_cookie}) {
		my @send_cookies;
		while(my ($k,$v) = each(%$cookie)) {
			$k =~ /(.*);/;
			my $chost = $1;
			if ($chost eq $host
			 || (substr($chost, 0, 1) eq '.' && index($host, substr($chost, 1)) >=0) ) {
			 	if ($v->{path} && index($path, $v->{path}) < 0) { next; }
			 	if ($v->{value} eq '') { next; }	# cookie̵
				$http_cookie .= "$v->{name}=$v->{value};";
				# print "Cookie : $v->{name}=$v->{value}\n";
			}
		}
		if ($http_cookie) { $http_cookie = "Cookie: $http_cookie\n"; }
	}

	#----------------------------------------------------------------------
	# إåν
	#----------------------------------------------------------------------
	my %header;
	if (ref($_header) eq 'HASH') { %header = %$_header; }	# copy
	$header{Host} ||= $host;
	$header{'User-Agent'} ||= $self->{http_agent};

	#----------------------------------------------------------------------
	# POSTꥯ
	#----------------------------------------------------------------------
	my $content;
	if ($method eq 'POST') {
		if (ref($post_data) eq 'HASH') {
			while(my ($k,$v) = each(%$post_data)) {
				$self->uri_encode($k,$v);
				$content .= "$k=$v&";
			}
			chop($content);
		} else {
			$content = $post_data;
		}
		$header{'Content-Length'} = length($content);
		$header{'Content-Type'} ||= 'application/x-www-form-urlencoded';
	}

	#----------------------------------------------------------------------
	# إåι
	#----------------------------------------------------------------------
	my $header;
	foreach(keys(%header)) {
		if ($_ eq '' || $_ =~ /[^\w\-]/) { next; }
		my $v = $header{$_};
		$v =~ s/^\s*//;
		$v =~ s/[\s\r\n]*$//;
		$header .= "$_: $v\n";
	}
	$header .= $http_cookie;

	#----------------------------------------------------------------------
	# HTTPꥯȤȯ
	#----------------------------------------------------------------------
	# $self->{ROBJ}->debug($header);
	# $self->{ROBJ}->debug($content);
	my $res;
	if ($https) {
		eval { require Net::SSLeay; };
		if ($@) {
			return $self->error(undef, "Net::SSLeay module not found (please install this server)");
		}
		my ($page, $result, %headers);
		if ($method eq 'POST') {
			($page, $result, %headers) = Net::SSLeay::post_https($host, $port, $path, $header, $content);
		} else {
			($page, $result, %headers) = Net::SSLeay::get_https ($host, $port, $path, $header);
		}

		$self->parse_status_line($result, $host);

		$res = [ $result ];
		foreach(keys(%headers)) {
			push(@$res, "$_: $headers{$_}");
		}
		push(@$res, '');
		push(@$res, $page);
	} else {
		my $request = "$method $path HTTP/1.0\n$header\n$content";
		$res = $self->get_data($host, $port, $request);
		if (ref($res) ne 'ARRAY') { return $res; }	# fail to return
	}

	#----------------------------------------------------------------------
	# إåβ
	#----------------------------------------------------------------------
	delete $self->{location};
	while(@$res) {
		my $line = shift(@$res);
		$line =~ s/[\r\n]//g;		# Խ
		if ($line eq '') { last; }	# إåν
		# Cookie
		if ($self->{use_cookie} && $line =~ /^set-cookie:\s*(.*)$/i) {
			my @cookie = split(/\s*;\s*/, $1);
			my %h;
			my $cookie_dom = $host;
			my ($name,$value) = split("=", shift(@cookie));
			$h{name}  = $name;
			$h{value} = $value;
			foreach(@cookie) {
				if ($_ !~ /(.*?)=(.*)/) { next; }
				$h{$1} = $2;
				if ($1 eq 'domain') {
					my $dom = $2;
					if ($dom =~ /\.?([\w\-]+\.[\w\-]+\.[\w\-]+)\.?/) {
						$cookie_dom = '.' . $1;
					}
				}
			}
			$cookie->{"$cookie_dom;$h{name}"} = \%h;	# cookie¸
		}
		# Redirect 
		if ($line =~ /^location:\s*(.*)$/i) {
			$self->{location} = $1;
		}
	}
	return $res;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ॢȤ
#------------------------------------------------------------------------------
sub set_timeout {
	my ($self, $timeout) = @_;
	$self->{timeout} = $timeout+0 || 30;
}

#------------------------------------------------------------------------------
# USER-AGENT
#------------------------------------------------------------------------------
sub set_agent {
	my $self = shift;
	$self->{http_agent} = shift || "Simple HTTP agent $VERSION";
}

#------------------------------------------------------------------------------
# URI󥳡
#------------------------------------------------------------------------------
sub uri_encode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w ])/'%' . unpack('H2', $1)/eg;
		$_ =~ tr/ /+/;
	}
}

###############################################################################
# 顼
###############################################################################
sub error_to_root {
	my $self = shift;
	$self->{error_to_root} = shift;
}

sub error {
	my $self   = shift;
	my $socket = shift;
	my $error  = shift;
	my $ROBJ   = $self->{ROBJ};
	if (defined $socket) { close($socket); }
	if (defined $ROBJ) {
		if ($self->{error_to_root}) { return $ROBJ->error($error, @_); }
		$error = $ROBJ->message_translate($error, @_);
	} elsif (@_) {
		$error = sprintf($error, @_);
	}
	$self->{error_msg} = $error;
	return undef;
}


1;
